/* COPYRIGHT NOTICE
 *
 * This program comes from "The X Toolkit Cookbook" by Paul E. Kimball
 * c. 1995 Prentice Hall.
 *
 *  HDR1: Example 5-2 - reverse.c - Setting and getting run-time resources
 *  
 *  HDR2: Chapter 5, page 80
 *
 * This software is provided free of charge and may be freely distributed
 * in its original form, so long as this notice appears unchanged in each 
 * copy.  This software is supplied "as-is" and is not covered by warrantee
 * of any kind, express or implied.  
 *
 * This and other examples are available by anonymous ftp from
 * ftp.netcom.com, directory "pub/pk/pkimball/cookbook".
 *
 *  1/15/95	Paul Kimball - pkimball@netcom.com
 */

/****** Include required header files *******************************/

#include <X11/Intrinsic.h>         /* The Intrinsics                */
#include <Xm/Xm.h>                 /* Resource symbols              */
#include <Xm/BulletinB.h>          /* Motif XmBulletinBoard widget  */
#include <Xm/PushB.h>              /* Motif XmPushButton widget     */

/****** Declare global variables ************************************/

XtAppContext context;
Widget       toplevel, manager, reverse_button;
void         Reverse();

/****** Start of main() *****************************************/

main(argc,argv)
int  argc;
char **argv;
{
 toplevel = XtAppInitialize( &context, "Reverse", NULL, 0, 
     &argc, argv, NULL, NULL, 0);

 manager = XtCreateManagedWidget( "manager",
     xmBulletinBoardWidgetClass, toplevel, NULL, 0);

 reverse_button = XtCreateManagedWidget( "reverseButton", 
     xmPushButtonWidgetClass, manager, NULL, 0);
 XtAddCallback( reverse_button, XmNactivateCallback, 
     Reverse, NULL );

 XtRealizeWidget(toplevel);
 XtAppMainLoop(context);
}

/****** Callback Routines ***************************************/

void 
Reverse(w, client_data, call_data)
Widget   w;              /* Input argument - widget that called */
XtPointer client_data;   /* Input argument - application data   */
XtPointer call_data;     /* Input argument - call-specific data */
{     
    Pixel fg, bg;

    /* retrieve foreground and background colors */
    XtVaGetValues(w, XmNforeground, &fg, XmNbackground, &bg, NULL);

    /* set background = foreground and vice-versa */
    XtVaSetValues(w, XmNforeground, bg, XmNbackground, fg, NULL);
}
